/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KCONFIGLDAP_H_
#define _KCONFIGLDAP_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapplication.h>
#include <kmainwindow.h>

#include "kconfigldapview.h"


class KPrinter;
class KURL;

/**
 * This class serves as the main window for kconfigldap.  It handles the
 * menus, toolbars, and status bars.
 *
 * @short Main window class
 * @author Helio Chissini de Castro <helio@mandriva.com>
 * @version 0.2
 */
class kconfigldap : public KMainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    kconfigldap();

    /**
     * Default Destructor
     */
    virtual ~kconfigldap();

private slots:

    void optionsPreferences();
    void newToolbarConfig();

    void changeStatusbar(const QString& text);
    void changeCaption(const QString& text);

private:

    void setupActions();

private:
    kconfigldapView *m_view;

    KPrinter   *m_printer;
};

#endif // _KCONFIGLDAP_H_

