/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KCONFIGLDAPAPPDUMP_H
#define KCONFIGLDAPAPPDUMP_H

#include <kservicegroup.h>
#include <qmap.h>
#include <qstringlist.h>

#include "kconfigldapappdump_base.h"

class KProcess;
class kconfigldapView;

typedef QMap<QString,QString> KDEAppMap;

class kconfigldapAppDump : public kconfigldapappdump_base
{
		Q_OBJECT

	public:
		kconfigldapAppDump ( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
		~kconfigldapAppDump();

		QStringList kdeApps() const;
		QStringList nonkdeApps() const;
		void load ( KServiceGroup::Ptr group );
		void setupWidgets();
		void processDone ( const QString& app );

	private:
		KDEAppMap m_KDEApps;
		QStringList m_NonKDEApps;
		kconfigldapView *m_parent;

	protected slots:
		virtual void accept();
};

#endif

