/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KCONFIGLDAPDATABASE_H
#define KCONFIGLDAPDATABASE_H

#include <qvaluelist.h>

class QString;
class QStringList;
class QSqlDatabase;

class GroupData
{
	public:
		GroupData(): t(0) {}
		GroupData( unsigned int type, const QString& name, const QString& value )
	: t( type ), n( name ), v( value ) {}
		QString name() const { return n; }
		QString value() const { return v; }
		unsigned int type() const { return t; }
	private:
			unsigned int t;
			QString n;
			QString v;
};

typedef QValueList<GroupData> GroupDataEntries;

/**
	@author Helio Chissini de Castro <helio@mandriva.com>
*/
class kconfigldapDatabase{
public:
    kconfigldapDatabase();

    ~kconfigldapDatabase();
    QStringList getApplications() const;
	 QStringList getAllResources() const;
	 QStringList getAppResources( const QString& app ) const;
    QStringList getGroups( const QString& res ) const;
    GroupDataEntries getGroupData( const QString& res, const QString& grp ) const;
	 void setGroupData( const QString& res, const QString& grp, const QString& entry, const QString& data ) const;
	 int addApplication( const QString& app ) const;
    void addAppRes( int app, int res );
    int addResource( const QString& res ) const;
    int addGroup( int res, const QString& grp ) const;
    void addEntry( int grpid, int type, const QString& name, const QString& entryval );

private:
    QSqlDatabase *m_sqlitedb;
private:
    void setupDB();
};

#endif
