/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kconfigldapview.h"
#include "kconfigldapldif.h"

#include <qstringlist.h>
#include <qlistview.h>
#include <qheader.h>
#include <qlabel.h>
#include <kcombobox.h>

kconfigldapLdif::kconfigldapLdif(QWidget* parent, const char* name, bool modal, WFlags fl)
: kconfigldapldif_base(parent,name, modal,fl)
{
	QStringList list;
	QStringList::iterator it;
	kconfigldapView *view = (kconfigldapView *)parent;

	ldifList->header()->setStretchEnabled ( true, -1 );
	ldifList->header()->adjustHeaderSize();
	ldifList->clear();

	list = view->getDb()->getAllResources();

	QCheckListItem *itRoot = new QCheckListItem ( ldifList, "All apps", QCheckListItem::CheckBoxController );
	
	for ( it = list.begin(); it != list.end(); ++it )
	{
		QCheckListItem *itParent = new QCheckListItem ( itRoot, ( *it ).latin1(), QCheckListItem::CheckBoxController );
		QStringList groups = view->getDb()->getGroups ( *it );
		QStringList::iterator resit;
		for ( resit = groups.begin(); resit != groups.end(); ++resit )
		{
			QCheckListItem *itRes = new QCheckListItem ( itParent, ( *resit ).latin1(), QCheckListItem::CheckBox );
			new QCheckListItem ( itRes, "Immutable", QCheckListItem::CheckBox );
		}
		itParent->setOpen( true );
	}

	itRoot->setOpen( true );

	// Update the suffix with default entries
	suffixChanged();

}

kconfigldapLdif::~kconfigldapLdif()
{
}

void kconfigldapLdif::suffixChanged()
{
	QString base = ldifGroup->currentText();
	base += ",ou=KDEConfig,";
	base += ldifSuffix->currentText();

	ldifSuffixResult->setText( base );
}


#include "kconfigldapldif.moc"

