/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KCONFIGLDAPVIEW_H_
#define _KCONFIGLDAPVIEW_H_

#include <qwidget.h>

#include "kconfigldapview_base.h"
#include "kconfigldapdatabase.h"

class QPainter;
class KURL;

enum ConfigTypes
{
    STRINGTYPE=0, BOOLTYPE=1, NUMTYPE=2, DOUBLETYPE=3, LISTTYPE=4,
    COLORTYPE=5,
    FONTTYPE=6,
    UNSIGNEDTYPE=7,
	 INVALIDTYPE=100
};

/**
 * This is the main view class for kconfigldap.  Most of the non-menu,
 * non-toolbar, and non-statusbar (e.g., non frame) GUI code should go
 * here.
 *
 * @short Main view
 * @author Helio Chissini de Castro <helio@mandriva.com>
 * @version 0.2
 */
class kconfigldapView : public kconfigldapview_base
{
		Q_OBJECT
	public:
		/**
		 * Default constructor
		 */
		kconfigldapView ( QWidget *parent );

		/**
		 * Destructor
		 */
		virtual ~kconfigldapView();
		void setupWidgets();
		kconfigldapDatabase* getDb() { return m_db; }
		void updateApplicationListView();
    ConfigTypes getTypeId( const QString& type ) const;

	signals:
		/**
		 * Use this signal to change the content of the statusbar
		 */
		void signalChangeStatusbar ( const QString& text );

		/**
		 * Use this signal to change the content of the caption
		 */
		void signalChangeCaption ( const QString& text );

	protected:
		kconfigldapDatabase *m_db;
		QString m_currentResource;
		QString m_currentGroup;

	public slots:
		virtual void updateResourceListView ( QListViewItem *item );
		virtual void updateDataTable ( QListViewItem *item );
		virtual void updateItem( int, int );
	private slots:
		void dumpConfig();
		void exportLDIF();
};

#endif // _KCONFIGLDAPVIEW_H_
