/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "qcolortableitem.h"
#include "kcolorbutton.h"

QColorTableItem::QColorTableItem( QTable *t, EditType et, const QString &txt, const QColor& c ) :
		QTableItem ( t, et, txt ), color( c ), colorButton( 0 )
{
	setReplaceable( FALSE );
}


QWidget *QColorTableItem::createEditor() const
{
	( (QColorTableItem*)this )->colorButton = new KColorButton( color, table()->viewport(), "ldap_color_item" );
	QObject::connect( colorButton, SIGNAL( changed( const QColor & ) ), table(), SLOT( doValueChanged() ) );
	return colorButton;
}

void QColorTableItem::setContentFromEditor( QWidget *w )
{
	if ( w->inherits( "KColorButton" ) )
	{
		color = ((KColorButton*)w)->color();
	}
	else
		QTableItem::setContentFromEditor( w );
}

void QColorTableItem::setText( const QString &s )
{
	if ( colorButton )
		colorButton->setColor( QColor( color ) );
	QTableItem::setText( s );
}

QString QColorTableItem::text() const
{
	return colorButton->color().name();
}