/***************************************************************************
 *   Copyright (C) 2007 by Helio Chissini de Castro   *
 *   helio@mandriva.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "qfonttableitem.h"

#include <qfont.h>
#include <kfontrequester.h>

QFontTableItem::QFontTableItem( QTable *t, EditType et, const QString &txt, const QFont& c ) :
		QTableItem ( t, et, txt ), font( c ), fontButton( 0 )
{
}


QWidget *QFontTableItem::createEditor() const
{
	( (QFontTableItem*)this )->fontButton = new KFontRequester( table()->viewport(), "ldap_font_item" );
	fontButton->setFont( font );
	QObject::connect( fontButton, SIGNAL( fontSelected( const QFont& ) ), table(), SLOT( doValueChanged() ) );
	return fontButton;
}

void QFontTableItem::setContentFromEditor( QWidget *w )
{
	if ( w->inherits( "KFontRequester" ) )
	{
		font = fontButton->font();
	}
}

void QFontTableItem::setText( const QString &s )
{
	if ( fontButton )
		fontButton->setFont( font );
	QTableItem::setText( s );
}
